// This file is part of cxsd, copyright (c) 2015-2016 BusFaster Ltd.
// Released under the MIT license, see LICENSE.
"use strict";
var cget_1 = require('cget');
var Namespace_1 = require('./xsd/Namespace');
var Loader_1 = require('./xsd/Loader');
var Exporter_1 = require('./xsd/Exporter');
var schema = require('./schema');
var AddImports_1 = require('./schema/transform/AddImports');
var Sanitize_1 = require('./schema/transform/Sanitize');
var ListImports_1 = require('./schema/transform/ListImports');
cget_1.Cache.patchRequest();
Namespace_1.Namespace.register('http://www.w3.org/XML/1998/namespace', 'http://www.w3.org/2001/xml.xsd', 'xml');
var loader = new Loader_1.Loader({
    forceHost: '127.0.0.1',
    forcePort: 12345
});
loader.import(process.argv[2]).then(function (namespace) {
    try {
        Exporter_1.exportNamespace(Namespace_1.PrimitiveSpace.get());
        var spec = Exporter_1.exportNamespace(namespace);
        new AddImports_1.AddImports(spec).exec().then(function () {
            return new Sanitize_1.Sanitize(spec).exec();
        }).then(function () {
            return new ListImports_1.ListImports(spec).exec();
        }).then(function () {
            return new schema.exporter.JS(spec).exec();
        }).then(function () {
            return new schema.exporter.TS(spec).exec();
        });
    }
    catch (err) {
        console.log(err);
        console.log(err.stack);
    }
});
