import * as Promise from 'bluebird';
import { Transform } from '../transform/Transform';
import { Cache } from 'cget';
export declare abstract class Exporter extends Transform<string> {
    writeHeader(): string[];
    abstract writeImport(shortName: string, relativePath: string): string;
    /** Output namespace contents to cache, if not already exported. */
    prepare(): Promise<boolean>;
    abstract writeContents(): string;
    /** Get relative path to another namespace within the cache. */
    getPathTo(name: string): string;
    abstract getCache(): Cache;
    protected abstract getOutName(name: string): string;
    /** Full path of directory containing exported output for the current namespace. */
    protected cacheDir: string;
    protected output: string;
}
