import * as Promise from 'bluebird';
import { Namespace } from '../Namespace';
import { Type } from '../Type';
import { Member } from '../Member';
export declare abstract class Transform<Output> {
    constructor(doc: Type);
    getTypeMembers(type: Type): Member[];
    prepare(): boolean | Promise<any>;
    exec(): Promise<Namespace>;
    construct: {
        new (...args: any[]): Transform<Output>;
    };
    private visitedNamespaceTbl;
    protected doc: Type;
    protected namespace: Namespace;
}
